<?php
/**
 * SM FAQ - simple faq component for Joomla! 1.5
 * @version 1.3.2
 * @package SM FAQ
 * @author SmokerMan
 * @author url http://joomla-code.ru
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class SmfaqController extends JController
{
	/**
	 * Method to display the view
	 *
	 * @access	public
	 */
	function display()
	{

		$user = &JFactory::getUser();
		if (!$user->guest) {
			parent::display(false);
		} else {
			parent::display(true);
		}
	}

	function addquestion()
	{
		$ip = $_SERVER['REMOTE_ADDR'];
		$protecttime = $this->_protect($ip);

		if ($protecttime == 'OK') {
			$view = & $this->getView('smfaq', 'html');
			$view->setLayout('form');
			$view->displayForm();
		} else {
			$protecttime =  JHTML::_('date',  $protecttime,  JText::_('COM_SMFAQ_DATE_FORMAT') );
			echo '<div id="prot">'.JText::_('COM_SMFAQ_ADD_NEXT_QUESTION').' '.$protecttime.'</div>';
		}

	}

	function _protect($ip)
	{
		global $mainframe;
		$db		=& JFactory::getDBO();
		$datenow =& JFactory::getDate();
		$date_now = $datenow->toMySQL();
		$params = $mainframe->getParams();
		$protectInterval = $params->get('prot_time', 0);

		$query = "SELECT DATE_ADD(created, INTERVAL " . $protectInterval . " MINUTE)".
				"\nFROM #__smfaq ".
			    "\nWHERE ip = '$ip' ".
				"\nORDER BY created desc";

		$db->setQuery( $query );
		$protecttime = $db->loadResult();
		if ($date_now > $protecttime ) {
			$protecttime = 'OK';
		} else {
		}
			
		return $protecttime;
	}

	function send()
	{
		global $mainframe;

		$user = & JFactory::getUser();
		$res['valid'] = false;
		$res['msg'] = '';
		$res['items'] = array();
		$ip = $_SERVER['REMOTE_ADDR'];

		$Itemid = JRequest::getInt('Itemid',null,'POST');
		if ($Itemid) {
			$menus = &JSite::getMenu();
			$menu  = $menus->getItem($Itemid);
		}
		if (is_object($menu) &&  $menu->query['view'] == 'category') {
			$params = new JParameter( $menu->params );
		} else 	{
			$params = &JComponentHelper::getParams( 'com_smfaq' );
		}

		if (($params->get('add_question', 2) > $user->get('aid', 0)) || ($this->_protect($ip) !== 'OK'))  {
			JError::raiseError( 403, JText::_('COM_SMFAQ_ALERTNOTAUTH') );
			return;
		}
		require_once(JPATH_SITE.DS.'libraries/phputf8/utf8.php');
		if ($user->guest)
		{
			$post['userid'] = null;
			$name = JRequest::getVar('created_by');
			if (preg_match('/[\"\'\[\]\=\<\>\(\)\;]+/', $name ) || (utf8_strlen($name) < 3 )) {
				$res['items'][] = array('name' => 'created_by', 'status' => 0, 'msg' => JText::_('COM_SMFAQ_WRONG_NAME'));
				$Validname = false;
			} else {
				$res['items'][] = array('name' => 'created_by', 'status' => 1);
				$post['created_by'] = $name;
				$Validname = true;
			}
			$email = JRequest::getVar('email');
			if(strlen($email) < 4 || !preg_match('#^([_a-z0-9-]+)(\.[_a-z0-9-]+)*@([a-z0-9-]+)(\.[a-z0-9-]+)*(\.[a-z]{2,4})$#i', $email)) {
				$res['items'][] = array('name' => 'email', 'status' => 0, 'msg' => JText::_('COM_SMFAQ_WRONG_EMAIL'));
				$Validemail = false;
			} else {
				$res['items'][] = array('name' => 'email', 'status' => 1);
				$post['email'] = $email;
				$Validemail = true;
			}
		} else {
			$post['created_by'] = $user->username;
			$post['email'] = $user->email;
			$post['userid'] = $user->id;
			$Validname = true;
			$Validemail = true;
		}
		$question = JRequest::getString('question');
		if(utf8_strlen($question) < $params->get('min_length', 10)) {
			$res['items'][] = array('name' => 'question', 'status' => 0, 'msg' => JText::sprintf('COM_SMFAQ_WRONG_QUESTION', $params->get('min_length')));
			$Validquestion = false;
		} else {
			$res['items'][] = array('name' => 'question', 'status' => 1);
			$post['question'] = $question;
			$Validquestion = true;
		}

		if ($params->get('show_captcha') > $user->get('aid')) {
			$captcha = JRequest::getVar('captcha');
			if ($captcha !== $_SESSION['captcha-code']) {
				$res['items'][] = array('name' => 'captcha', 'status' => 0, 'msg' => JText::_('COM_SMFAQ_WRONG_CAPTCHA'));
				$Validcaptcha = false;
			} else {
				$res['items'][] = array('name' => 'captcha', 'status' => 1);
				$Validcaptcha = true;
			}
		} else {
			$Validcaptcha = true;
		}
		if ($Validname && $Validemail &&  $Validquestion && $Validcaptcha) {
			$send_mail = JRequest::getInt('send_mail');
			$post['ip'] = $ip;
			$post['send_mail'] = $send_mail;
			$post['catid'] = JRequest::getInt('catid');
			$model = $this->getModel('smfaq');
			if ($model->store($post)) {
				$res['valid'] = true;
				if ($send_mail) {
					$res['msg'] = JText::_('COM_SMFAQ_FORM_SEND_OK_SUB');
				} else {
					$res['msg'] = JText::_('COM_SMFAQ_FORM_SEND_OK');
				}
				if ($params->get('send_mail_admin'))
				$this->sendMail($question, $post['created_by'], $params);
					
			} else {
				$res['msg'] = $model->getError();
			}

		}

		if (!function_exists('json_encode')) {
			require_once(JPATH_COMPONENT.DS.'library'.DS.'json.php');
			$json = new Services_JSON();
			echo $json->encode($res);
		} else {
			echo json_encode($res);
		}
		return;
	}

	function sendMail($question, $name, $params)
	{
		require_once(JPATH_COMPONENT.DS.'helpers'.DS.'route.php');
		global $mainframe;

		$db		=& JFactory::getDBO();
		$datenow =& JFactory::getDate();

		$created	= JHTML::_('date',  $datenow->toMySQL(),  JText::_('COM_SMFAQ_DATE_FORMAT') );
		$catid  	= JRequest::getInt('catid', '', 'POST');
		$sitename 		= $mainframe->getCfg( 'sitename' );
		$mailfrom 		= $mainframe->getCfg( 'mailfrom' );
		$fromname 		= $mainframe->getCfg( 'fromname' );


		$query = 'SELECT c.title' .
				' FROM #__categories AS c' .
				' WHERE c.id = '. (int) $catid;
		$db->setQuery( $query );
		$cattitle = $db->loadResult();

		$subject = JText::_( 'COM_SMFAQ_SEND_NEW_QUESTION' );

		$message = JText::_( 'COM_SMFAQ_CATEGORY' ). ' - ' . $cattitle. "\n";
		$message .= JText::_( 'COM_SMFAQ_AUTHOR' ). ': ' . $name . " " . JText::_( 'COM_SMFAQ_DATE' ). ': ' . $created;
		$message .= "\n\n". JText::_( 'COM_SMFAQ_QUESTION' ). ": \n\n" . $question. "\n\n";
		$link = preg_replace("/(.*).$/", "\\1", JURI::root()).JRoute::_(SmfaqHelperRoute::getCategoryRoute($catid));
		$message .=  $link ;


		switch ($params->get('send_mail_admin'))
		{
			case '1':
				$where = ' WHERE gid = "25" ';
				break;
			case '2':
				$where = ' WHERE gid = "24"' ;
				break;
			case '3':
				$where = ' WHERE gid = "23" ';
				break;
			case '4':
			default:
				$where = ' WHERE gid IN (23,24,25) ';
				break;
		}
		$query = 'SELECT email, sendEmail' .
				' FROM #__users' .
		$where;
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		foreach ( $rows as $row )
		{
			if ($row->sendEmail)
			{
				JUtility::sendMail($mailfrom, $fromname, $row->email, $subject, $message);
			}
		}
		return;
	}

	function storevote()
	{
		global $mainframe;
		$userIP =  $_SERVER['REMOTE_ADDR'];
		$id = JRequest::getInt('id');
		$vote_value = JRequest::getInt('vote');
		$db		=& JFactory::getDBO();
		$res['valid'] = true;
		$res['msg'] = '<strong>'.JText::_('COM_SMFAQ_SANKS_FOR_VOTE').'</strong>';
			
		if ($vote_value) {
			$vote_value = 'vote_yes';
		} else {
			$vote_value = 'vote_no';
		}

		$query = 'SELECT *' .
				' FROM #__smfaq_votes' .
				' WHERE question_id = '.(int) $id;
		$db->setQuery($query);
		$voting = $db->loadObject();

		$cookieName	= JUtility::getHash( $mainframe->getName() . 'smfaq' . (int) $id );
		$voted = JRequest::getVar( $cookieName, '0', 'COOKIE', 'INT');

		if (!$voting)
		{
			setcookie( $cookieName, '1');
			// There are no ratings yet, so lets insert our rating
			$query = 'INSERT INTO #__smfaq_votes ( question_id, lastip, '.$vote_value.' )' .
					' VALUES ( '.(int) $id.', '.$db->Quote($userIP).', 1 )';
			$db->setQuery($query);
			if (!$db->query()) {
				JError::raiseError( 500, $db->stderr());
			}
			if ($vote_value == 'vote_no') {
				$res['msg'] = '<div id="sm-comment-form-'.$id.'" class="sm-comment-form" style="display:inline-block"><div class="sm-comment-title">'.JText::_('COM_SMFAQ_COMMENT_TITLE').'</div>';
				$res['msg'] .= '<textarea id="sm-comment-'.$id.'" class="sm-comment"></textarea><br /><br />';
				$res['msg'] .= '<span class="sm-button" onclick="javascript:comment('.$id .')">'.JText::_('COM_SMFAQ_SEND').'</span></div>';
				if (!function_exists('json_encode')) {
					require_once(JPATH_COMPONENT.DS.'library'.DS.'json.php');
					$json = new Services_JSON();
					echo $json->encode($res);
				} else {
					echo json_encode($res);
				}
				return;
			}
		} else {
			if (($userIP != $voting->lastip) && !$voted)
			{
				if ($vote_value == 'vote_no') {
					$res['msg'] = '<div id="sm-comment-form-'.$id.'" class="sm-comment-form" style="display:inline-block"><div class="sm-comment-title">'.JText::_('COM_SMFAQ_COMMENT_TITLE').'</div>';
					$res['msg'] .= '<textarea id="sm-comment-'.$id.'" class="sm-comment"></textarea><br /><br />';
					$res['msg'] .= '<span class="sm-button" onclick="javascript:comment('.$id .')">'.JText::_('COM_SMFAQ_SEND').'</span></div>';
				}
				setcookie( $cookieName, '1');
				// We weren't the last voter so lets add our vote to the ratings totals for the article
				$query = 'UPDATE #__smfaq_votes' .
						' SET '.$vote_value.' = '.$vote_value.' + 1, lastip = '.$db->Quote($userIP) .
						' WHERE question_id = '.(int) $id;
				$db->setQuery($query);
				if (!$db->query()) {
					JError::raiseError( 500, $db->stderr());
				}
			} else {
				$res['valid'] = false;
				$res['msg'] = '<strong>'.JText::_('COM_SMFAQ_VOTED').'</strong>';
			}
		}
		if (!function_exists('json_encode')) {
			require_once(JPATH_COMPONENT.DS.'library'.DS.'json.php');
			$json = new Services_JSON();
			echo $json->encode($res);
		} else {
			echo json_encode($res);
		}
		return;
	}

	function captcha()
	{
		require_once(JPATH_COMPONENT.DS.'helpers'.DS.'captcha.php');
		SmfaqHelperCaptcha::image();
	}

	function comment() {
		$id = JRequest::getInt('id','','POST');
		$comment = JRequest::getVar('comment','','POST');
		$res['valid'] = true;
		if(strlen($comment ) < 10 ) {
			$res['valid'] = false;
			$res['msg'] = JText::_('COM_SMFAQ_COMMENT_ERR_MSG');
			if (!function_exists('json_encode')) {
				require_once(JPATH_COMPONENT.DS.'library'.DS.'json.php');
				$json = new Services_JSON();
				echo $json->encode($res);
			} else {
				echo json_encode($res);
			}
			return;
		}

		$db		=& JFactory::getDBO();
		$query = 'INSERT INTO #__smfaq_comments (question_id,comment)'.
				' VALUES ('.(int) $id.',' .$db->Quote($comment). ')';
		$db->setQuery($query);
		if (!$db->query()) {
			JError::raiseError( 500, $db->stderr());
		}

		$res['msg'] = JText::_('COM_SMFAQ_THANKS_FOR_COMMENT');
		if (!function_exists('json_encode')) {
			require_once(JPATH_COMPONENT.DS.'library'.DS.'json.php');
			$json = new Services_JSON();
			echo $json->encode($res);
		} else {
			echo json_encode($res);
		}
		return;

	}

}