<?php
/**
 * SM FAQ - simple faq component for Joomla! 1.5
 * @version 1.3.2
 * @package SM FAQ
 * @author SmokerMan
 * @author url http://joomla-code.ru
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class SmfaqModelCategories extends JModel
{
	/**
	 * Categories data array
	 *
	 * @var array
	 */
	var $_data = null;

	/**
	 * Categories total
	 *
	 * @var integer
	 */
	var $_total = null;

	/**
	 * Constructor
	 *
	 * @since 1.5
	 */

	function __construct()
	{
		parent::__construct();

	}

	function getData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query);
		}

		return $this->_data;
	}

	function getTotal()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	function _buildQuery()
	{
		global $mainframe;
		
		$user =& JFactory::getUser();
		$aid = $user->get('aid', 0);
		
		$count = ' SUM(a.published) ';
		
		$params = &$mainframe->getParams();
		if ($params->get('show_empty')) {
			$where = null;
		} else {
			$where = ' AND a.published = 1';
		}
		if ($user->gid > 22){
			$count = ' COUNT(a.id) ';
			$where = null;
		}
						 
		$query = 'SELECT cc.*, '.$count.' AS numquestion,'
			. 'CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(\':\', cc.id, cc.alias) ELSE cc.id END as slug'
			.' FROM #__categories AS cc'
			.' LEFT JOIN #__smfaq AS a ON a.catid = cc.id'
			.' WHERE section = \'com_smfaq\''
			.' AND cc.published = 1'
			.' AND cc.access <= '.(int) $aid
			. $where
			.' GROUP BY cc.id'
			.' ORDER BY cc.ordering';

		return $query;
	}
}
?>
